Index: /branches/IslandALPS/IslandALPS/3.3/GroupedLayerOperator.cs
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/GroupedLayerOperator.cs	(revision 13685)
+++ /branches/IslandALPS/IslandALPS/3.3/GroupedLayerOperator.cs	(revision 13686)
@@ -115,5 +115,5 @@
     }
 
-    //TODO: Copied from ResultsHistoryWiper, When integrate create static apply method and delete this
+    //TODO: HL-INTEGRATION :Copied from ResultsHistoryWiper, When integrate create static apply method and delete this
     private static void ClearHistoryRecursively(ResultCollection results) {
       var values = results.Select(r => r.Value);
Index: /branches/IslandALPS/IslandALPS/3.3/HeuristicLab.Algorithms.IslandALPS-3.3.csproj
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/HeuristicLab.Algorithms.IslandALPS-3.3.csproj	(revision 13685)
+++ /branches/IslandALPS/IslandALPS/3.3/HeuristicLab.Algorithms.IslandALPS-3.3.csproj	(revision 13686)
@@ -105,8 +105,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="IslandAlpsAlgorithmMainLoop.cs" />
     <Compile Include="LayerMigrator.cs" />
+    <Compile Include="Offspring Selection\IslandAlpsOffspringSelectionAlgorithm.cs" />
+    <Compile Include="Offspring Selection\IslandAlpsOffspringSelectionAlgorithmMainLoop.cs" />
     <Compile Include="ResultsExtractor.cs" />
     <Compile Include="IslandALPSAlgorithm.cs" />
-    <Compile Include="IslandALPSAlgorthmsMainLoop.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -116,4 +118,5 @@
     <None Include="HeuristicLab.snk" />
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/IslandALPS/IslandALPS/3.3/IslandALPSAlgorithm.cs
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/IslandALPSAlgorithm.cs	(revision 13685)
+++ /branches/IslandALPS/IslandALPS/3.3/IslandALPSAlgorithm.cs	(revision 13686)
@@ -2,5 +2,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Security.Policy;
 using HeuristicLab.Algorithms.ALPS;
 using HeuristicLab.Analysis;
@@ -41,180 +40,152 @@
 
     #region ALPSParameter
-    private IValueParameter<IntValue> AgeGapParameter {
-      get { return (IValueParameter<IntValue>) Parameters["AgeGap"]; }
-    }
-    private IValueParameter<EnumValue<AgingScheme>> AgingSchemeParameter {
-      get { return (IValueParameter<EnumValue<AgingScheme>>)Parameters["AgingScheme"]; }
-    }
-    private IValueParameter<DoubleValue> AgeInheritanceParameter {
-      get { return (IValueParameter<DoubleValue>) Parameters["AgeInheritance"]; }
-    }
-    private IValueParameter<IntArray> AgeLimitsParameter {
-      get { return (IValueParameter<IntArray>) Parameters["AgeLimits"]; }
-    }
-    private IValueParameter<BoolValue> ReduceToPopulationSizeParameter {
-      get { return (IValueParameter<BoolValue>) Parameters["ReduceToPopulationSize"]; }
-    }
-    private IValueParameter<IntValue> NumberOfLayersParameter {
-      get { return (IValueParameter<IntValue>) Parameters["NumberOfLayers"]; }
-    }
-    private IValueParameter<MultiAnalyzer> LayerAnalyzerParameter {
-      get { return (IValueParameter<MultiAnalyzer>)Parameters["LayerAnalyzer"]; }
-    }
-    private IValueParameter<MultiAnalyzer> GroupAnalyzerParameter {
-      get { return (IValueParameter<MultiAnalyzer>)Parameters["GroupAnalyzer"]; }
-    }
-    private IValueParameter<BoolValue> PlusSelectionParameter {
-      get { return (IValueParameter<BoolValue>)Parameters["PlusSelection"]; }
-    }
+
+    public IValueParameter<IntValue> AgeGapParameter { get { return (IValueParameter<IntValue>) Parameters["AgeGap"]; } }
+
+    public IValueParameter<EnumValue<AgingScheme>> AgingSchemeParameter { get { return (IValueParameter<EnumValue<AgingScheme>>) Parameters["AgingScheme"]; } } 
+    public IValueParameter<DoubleValue> AgeInheritanceParameter {   get { return (IValueParameter<DoubleValue>) Parameters["AgeInheritance"]; } } 
+    public IValueParameter<IntArray> AgeLimitsParameter {   get { return (IValueParameter<IntArray>) Parameters["AgeLimits"]; }   } 
+    public IValueParameter<BoolValue> ReduceToPopulationSizeParameter {   get { return (IValueParameter<BoolValue>) Parameters["ReduceToPopulationSize"]; }   } 
+    public IValueParameter<IntValue> NumberOfLayersParameter {   get { return (IValueParameter<IntValue>) Parameters["NumberOfLayers"]; } } 
+    public IValueParameter<MultiAnalyzer> LayerAnalyzerParameter {   get { return (IValueParameter<MultiAnalyzer>) Parameters["LayerAnalyzer"]; } } 
+    public IValueParameter<MultiAnalyzer> GroupAnalyzerParameter {   get { return (IValueParameter<MultiAnalyzer>) Parameters["GroupAnalyzer"]; } } 
+    public IValueParameter<BoolValue> PlusSelectionParameter {   get { return (IValueParameter<BoolValue>) Parameters["PlusSelection"]; } } 
     #endregion
 
     #region IslandParameter
-    private IValueParameter<MultiAnalyzer> IslandAnalyzerParameter {
-      get { return (IValueParameter<MultiAnalyzer>) Parameters["IslandAnalyzer"]; }
-    }
-    private IValueParameter<IntValue> NumberOfIslandsParameter {
-      get { return (IValueParameter<IntValue>) Parameters["NumberOfIslands"]; }
-    }
-    private IValueParameter<PercentValue> MigrationRateParameter {
-      get { return (IValueParameter<PercentValue>)Parameters["MigrationRate"]; }
-    }
-    private IValueParameter<IntValue> MigrationIntervalParameter {
-      get { return (IValueParameter<IntValue>)Parameters["MigrationInterval"]; }
-    }
-    public IConstrainedValueParameter<IMigrator> MigratorParameter {
-      get { return (IConstrainedValueParameter<IMigrator>)Parameters["Migrator"]; }
-    }
-    public IConstrainedValueParameter<ISelector> EmigrantsSelectorParameter {
-      get { return (IConstrainedValueParameter<ISelector>)Parameters["EmigrantsSelector"]; }
-    }
-    public IConstrainedValueParameter<IReplacer> ImmigrationReplacerParameter {
-      get { return (IConstrainedValueParameter<IReplacer>)Parameters["ImmigrationReplacer"]; }
-    }
+
+    public IValueParameter<MultiAnalyzer> IslandAnalyzerParameter {   get { return (IValueParameter<MultiAnalyzer>) Parameters["IslandAnalyzer"]; } } 
+    public IValueParameter<IntValue> NumberOfIslandsParameter {   get { return (IValueParameter<IntValue>) Parameters["NumberOfIslands"]; } } 
+    public IValueParameter<PercentValue> MigrationRateParameter {   get { return (IValueParameter<PercentValue>) Parameters["MigrationRate"]; } } 
+    public IValueParameter<IntValue> MigrationIntervalParameter {   get { return (IValueParameter<IntValue>) Parameters["MigrationInterval"]; } } 
+    public IConstrainedValueParameter<IMigrator> MigratorParameter {   get { return (IConstrainedValueParameter<IMigrator>) Parameters["Migrator"]; } } 
+    public IConstrainedValueParameter<ISelector> EmigrantsSelectorParameter {   get { return (IConstrainedValueParameter<ISelector>) Parameters["EmigrantsSelector"]; } } 
+    public IConstrainedValueParameter<IReplacer> ImmigrationReplacerParameter {   get { return (IConstrainedValueParameter<IReplacer>) Parameters["ImmigrationReplacer"]; } } 
     #endregion
 
     #region GeneralParameter
-    private IValueParameter<IntValue> SeedParameter {
-      get { return (IValueParameter<IntValue>) Parameters["Seed"]; }
-    }
-    private IValueParameter<BoolValue> SetSeedRandomlyParameter {
-      get { return (IValueParameter<BoolValue>) Parameters["SetSeedRandomly"]; }
-    }
-    private IValueParameter<IntValue> PopulationSizeParameter {
-      get { return (IValueParameter<IntValue>) Parameters["PopulationSize"]; }
-    }
-    private IValueParameter<MultiAnalyzer> AnalyzerParameter {
-      get { return (IValueParameter<MultiAnalyzer>) Parameters["Analyzer"]; }
-    }
-    public IConstrainedValueParameter<ISelector> SelectorParameter {
-      get { return (IConstrainedValueParameter<ISelector>) Parameters["Selector"]; }
-    }
-    public IConstrainedValueParameter<ICrossover> CrossoverParameter {
-      get { return (IConstrainedValueParameter<ICrossover>) Parameters["Crossover"]; }
-    }
-    private IValueParameter<PercentValue> MutationProbabilityParameter {
-      get { return (IValueParameter<PercentValue>) Parameters["MutationProbability"]; }
-    }
-    public IConstrainedValueParameter<IManipulator> MutatorParameter {
-      get { return (IConstrainedValueParameter<IManipulator>) Parameters["Mutator"]; }
-    }
-    private IValueParameter<IntValue> ElitesParameter {
-      get { return (IValueParameter<IntValue>) Parameters["Elites"]; }
-    }
-    private IFixedValueParameter<BoolValue> ReevaluateElitesParameter {
-      get { return (IFixedValueParameter<BoolValue>) Parameters["ReevaluateElites"]; }
-    }
-    private IValueParameter<MultiTerminator> TerminatorParameter {
-      get { return (IValueParameter<MultiTerminator>) Parameters["Terminator"]; }
-    }
-    #endregion
+
+    public IValueParameter<IntValue> SeedParameter {   get { return (IValueParameter<IntValue>) Parameters["Seed"]; } } 
+    public IValueParameter<BoolValue> SetSeedRandomlyParameter {   get { return (IValueParameter<BoolValue>) Parameters["SetSeedRandomly"]; } } 
+    public IValueParameter<IntValue> PopulationSizeParameter {   get { return (IValueParameter<IntValue>) Parameters["PopulationSize"]; } } 
+    public IValueParameter<MultiAnalyzer> AnalyzerParameter {   get { return (IValueParameter<MultiAnalyzer>) Parameters["Analyzer"]; } } 
+    public IConstrainedValueParameter<ISelector> SelectorParameter {   get { return (IConstrainedValueParameter<ISelector>) Parameters["Selector"]; } } 
+    public IConstrainedValueParameter<ICrossover> CrossoverParameter {   get { return (IConstrainedValueParameter<ICrossover>) Parameters["Crossover"]; } }
+    public IValueParameter<PercentValue> MutationProbabilityParameter {   get { return (IValueParameter<PercentValue>) Parameters["MutationProbability"]; } } 
+    public IConstrainedValueParameter<IManipulator> MutatorParameter {   get { return (IConstrainedValueParameter<IManipulator>) Parameters["Mutator"]; } }
+    public IValueParameter<IntValue> ElitesParameter {   get { return (IValueParameter<IntValue>) Parameters["Elites"]; } }
+    public IFixedValueParameter<BoolValue> ReevaluateElitesParameter {   get { return (IFixedValueParameter<BoolValue>) Parameters["ReevaluateElites"]; } }
+    public IValueParameter<MultiTerminator> TerminatorParameter {   get { return (IValueParameter<MultiTerminator>) Parameters["Terminator"]; } } 
+    #endregion
+
     #endregion
 
     #region Properties
+
     public IntValue Seed {
       get { return SeedParameter.Value; }
       set { SeedParameter.Value = value; }
     }
+
     public BoolValue SetSeedRandomly {
       get { return SetSeedRandomlyParameter.Value; }
       set { SetSeedRandomlyParameter.Value = value; }
     }
+
     public IntValue PopulationSize {
       get { return PopulationSizeParameter.Value; }
       set { PopulationSizeParameter.Value = value; }
     }
+
     public IntValue NumberOfIslands {
       get { return NumberOfIslandsParameter.Value; }
       set { NumberOfIslandsParameter.Value = value; }
     }
+
     public MultiAnalyzer Analyzer {
       get { return AnalyzerParameter.Value; }
       set { AnalyzerParameter.Value = value; }
     }
+
     public MultiAnalyzer IslandAnalyzer {
       get { return IslandAnalyzerParameter.Value; }
       set { IslandAnalyzerParameter.Value = value; }
     }
+
     public MultiAnalyzer LayerAnalyzer {
       get { return LayerAnalyzerParameter.Value; }
       set { LayerAnalyzerParameter.Value = value; }
     }
+
     public MultiAnalyzer GroupAnalyzer {
       get { return GroupAnalyzerParameter.Value; }
       set { GroupAnalyzerParameter.Value = value; }
     }
+
     public ISelector Selector {
       get { return SelectorParameter.Value; }
       set { SelectorParameter.Value = value; }
     }
+
     public ICrossover Crossover {
       get { return CrossoverParameter.Value; }
       set { CrossoverParameter.Value = value; }
     }
+
     public PercentValue MutationProbability {
       get { return MutationProbabilityParameter.Value; }
       set { MutationProbabilityParameter.Value = value; }
     }
+
     public IManipulator Mutator {
       get { return MutatorParameter.Value; }
       set { MutatorParameter.Value = value; }
     }
+
     public IntValue Elites {
       get { return ElitesParameter.Value; }
       set { ElitesParameter.Value = value; }
     }
+
     public bool ReevaluteElites {
       get { return ReevaluateElitesParameter.Value.Value; }
       set { ReevaluateElitesParameter.Value.Value = value; }
     }
+
     public MultiTerminator Terminators {
       get { return TerminatorParameter.Value; }
     }
+
     public EnumValue<AgingScheme> AgingScheme {
       get { return AgingSchemeParameter.Value; }
       set { AgingSchemeParameter.Value = value; }
     }
+
     public IntValue AgeGap {
       get { return AgeGapParameter.Value; }
       set { AgeGapParameter.Value = value; }
     }
+
     public DoubleValue AgeInheritance {
       get { return AgeInheritanceParameter.Value; }
       set { AgeInheritanceParameter.Value = value; }
     }
+
     public IntArray AgeLimits {
       get { return AgeLimitsParameter.Value; }
       set { AgeLimitsParameter.Value = value; }
     }
+
     public IntValue NumberOfLayers {
       get { return NumberOfLayersParameter.Value; }
       set { NumberOfLayersParameter.Value = value; }
     }
+
     #endregion
 
     #region Helper Properties
 
-    private IslandAlpsAlgorthmsMainLoop MainLoop {
-      get { return OperatorGraph.Iterate().OfType<IslandAlpsAlgorthmsMainLoop>().First(); }
+    private IslandAlpsAlgorithmMainLoop MainLoop {
+      get { return OperatorGraph.Iterate().OfType<IslandAlpsAlgorithmMainLoop>().First(); }
     }
 
@@ -246,6 +217,5 @@
 
     [StorableConstructor]
-    private IslandAlpsAlgorithm(bool deserializing) : base(deserializing) {
-    }
+    private IslandAlpsAlgorithm(bool deserializing) : base(deserializing) {}
 
     [StorableHook(HookType.AfterDeserialization)]
@@ -273,43 +243,6 @@
 
     public IslandAlpsAlgorithm() {
-      #region add Parameter
-      #region ALPSParameter
-      Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers.", new IntValue(5)));
-      Parameters.Add(new ValueParameter<DoubleValue>("AgeInheritance", "A weight that determines the age of a child after crossover based on the older (1.0) and younger (0.0) parent.", new DoubleValue(0.5)));
-      Parameters.Add(new ValueParameter<IntArray>("AgeLimits", "The maximum age an individual is allowed to reach in a certain layer.", new IntArray(new int[0])) { Hidden = true });
-      Parameters.Add(new ValueParameter<EnumValue<AgingScheme>>("AgingScheme", "The aging scheme for setting the age-limits for the layers.", new EnumValue<AgingScheme>(ALPS.AgingScheme.Polynomial)));
-      Parameters.Add(new ValueParameter<BoolValue>("ReduceToPopulationSize", ".", new BoolValue(true)));
-
-      Parameters.Add(new ValueParameter<IntValue>("NumberOfLayers", "", new IntValue(10)));
-      Parameters.Add(new ValueParameter<MultiAnalyzer>("LayerAnalyzer", "The operator used to analyze each layer.", new MultiAnalyzer()));
-      Parameters.Add(new ValueParameter<MultiAnalyzer>("GroupAnalyzer", "The operator used to analyze each layergroup.", new MultiAnalyzer()));
-      Parameters.Add(new ValueParameter<BoolValue>("PlusSelection", "Include the parents in the selection of the invividuals for the next generation.", new BoolValue(false)));
-
-      #endregion
-      #region IslandParameter
-      Parameters.Add(new ValueParameter<IntValue>("NumberOfIslands", "The number of islands.", new IntValue(5)));
-      Parameters.Add(new ValueParameter<PercentValue>("MigrationRate", "How many individuals should migrate.", new PercentValue(0.15)));
-      Parameters.Add(new ValueParameter<IntValue>("MigrationInterval", "The number Generations before a migration occurs.", new IntValue(20)));
-      Parameters.Add(new ValueParameter<MultiAnalyzer>("IslandAnalyzer", "The operator used to analyze each island.", new MultiAnalyzer()));
-      Parameters.Add(new ConstrainedValueParameter<IMigrator>("Migrator", "The migration strategy."));
-      Parameters.Add(new ConstrainedValueParameter<ISelector>("EmigrantsSelector", "Selects the individuals that will be migrated."));
-      Parameters.Add(new ConstrainedValueParameter<IReplacer>("ImmigrationReplacer", "Selects the population from the unification of the original population and the immigrants."));
-
-      #endregion
-      #region GeneralParameter   
-      Parameters.Add(new ValueParameter<IntValue>("Seed", "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
-      Parameters.Add(new ValueParameter<BoolValue>("SetSeedRandomly", "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
-      Parameters.Add(new ValueParameter<IntValue>("PopulationSize", "The size of the population of solutions.", new IntValue(100)));
-      Parameters.Add(new ValueParameter<MultiAnalyzer>("Analyzer", "The operator used to analyze the islands.", new MultiAnalyzer()));
-      Parameters.Add(new ConstrainedValueParameter<ISelector>("Selector", "The operator used to select solutions for reproduction."));
-      Parameters.Add(new ConstrainedValueParameter<ICrossover>("Crossover", "The operator used to cross solutions."));
-      Parameters.Add(new ValueParameter<PercentValue>("MutationProbability", "The probability that the mutation operator is applied on a solution.", new PercentValue(0.05)));
-      Parameters.Add(new OptionalConstrainedValueParameter<IManipulator>("Mutator", "The operator used to mutate solutions."));
-      Parameters.Add(new ValueParameter<IntValue>("Elites", "The numer of elite solutions which are kept in each generation.", new IntValue(1)));
-      Parameters.Add(new FixedValueParameter<BoolValue>("ReevaluateElites", "Flag to determine if elite individuals should be reevaluated (i.e., if stochastic fitness functions are used.)", new BoolValue(false)) { Hidden = true });
-      Parameters.Add(new ValueParameter<MultiTerminator>("Terminator", "The termination criteria that defines if the algorithm should continue or stop.", new MultiTerminator()));
-      #endregion
-
-      #endregion
+    
+      AddParameters();
 
       #region create Operators
@@ -330,5 +263,5 @@
       var globalEvaluatedSolutionsCounter = new DataReducer {Name = "Count GlobalSolutions"};
       var resultsCollector = new ResultsCollector();
-      var mainLoop = new IslandAlpsAlgorthmsMainLoop();
+      var mainLoop = new IslandAlpsAlgorithmMainLoop();
 
       #endregion
@@ -351,5 +284,4 @@
 
       #region Create Analyzers
-
       qualityAnalyzer = new BestAverageWorstQualityAnalyzer();
       islandQualityAnalyzer = new BestAverageWorstQualityAnalyzer();
@@ -360,9 +292,6 @@
       #region Create terminators
 
-      generationsTerminator = new ComparisonTerminator<IntValue>("Generations", ComparisonType.Less, new IntValue(1000)) {
-        Name = "Generations"
-      };
-      evaluationsTerminator = new ComparisonTerminator<IntValue>("EvaluatedSolutions", ComparisonType.Less,
-        new IntValue(int.MaxValue)) {Name = "Evaluations"};
+      generationsTerminator = new ComparisonTerminator<IntValue>("Generations", ComparisonType.Less, new IntValue(1000)) { Name = "Generations" };
+      evaluationsTerminator = new ComparisonTerminator<IntValue>("EvaluatedSolutions", ComparisonType.Less, new IntValue(int.MaxValue)) {Name = "Evaluations"};
       qualityTerminator = new SingleObjectiveQualityTerminator {Name = "Quality"};
       executionTimeTerminator = new ExecutionTimeTerminator(this, new TimeSpanValue(TimeSpan.FromMinutes(5)));
@@ -432,7 +361,9 @@
       globalEvaluatedSolutionsCounter.Successor = resultsCollector;
       resultsCollector.Successor = mainLoop;
-      
+
       #endregion
+
       #region parametrize
+
       ParameterizeAnalyzers();
       UpdateAnalyzers();
@@ -441,7 +372,53 @@
       ParameterizeAgeLimits();
       ParametrizeMigration();
+
       #endregion
 
       InitializeEventHandler();
+    }
+
+    private void AddParameters() {
+      #region ALPSParameter
+
+      Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers.", new IntValue(5)));
+      Parameters.Add(new ValueParameter<DoubleValue>("AgeInheritance", "A weight that determines the age of a child after crossover based on the older (1.0) and younger (0.0) parent.", new DoubleValue(1)));
+      Parameters.Add(new ValueParameter<IntArray>("AgeLimits", "The maximum age an individual is allowed to reach in a certain layer.", new IntArray(new int[0])) {Hidden = true});
+      Parameters.Add(new ValueParameter<EnumValue<AgingScheme>>("AgingScheme", "The aging scheme for setting the age-limits for the layers.", new EnumValue<AgingScheme>(ALPS.AgingScheme.Polynomial)));
+      Parameters.Add(new ValueParameter<BoolValue>("ReduceToPopulationSize", ".", new BoolValue(true)));
+
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfLayers", "", new IntValue(100000)));
+      Parameters.Add(new ValueParameter<MultiAnalyzer>("LayerAnalyzer", "The operator used to analyze each layer.", new MultiAnalyzer()));
+      Parameters.Add(new ValueParameter<MultiAnalyzer>("GroupAnalyzer", "The operator used to analyze each layergroup.", new MultiAnalyzer()));
+      Parameters.Add(new ValueParameter<BoolValue>("PlusSelection", "Include the parents in the selection of the invividuals for the next generation.", new BoolValue(false)));
+
+      #endregion
+
+      #region IslandParameter
+
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfIslands", "The number of islands.", new IntValue(5)));
+      Parameters.Add(new ValueParameter<PercentValue>("MigrationRate", "How many individuals should migrate.", new PercentValue(0.15)));
+      Parameters.Add(new ValueParameter<IntValue>("MigrationInterval", "The number Generations before a migration occurs.", new IntValue(20)));
+      Parameters.Add(new ValueParameter<MultiAnalyzer>("IslandAnalyzer", "The operator used to analyze each island.", new MultiAnalyzer()));
+      Parameters.Add(new ConstrainedValueParameter<IMigrator>("Migrator", "The migration strategy."));
+      Parameters.Add(new ConstrainedValueParameter<ISelector>("EmigrantsSelector", "Selects the individuals that will be migrated."));
+      Parameters.Add(new ConstrainedValueParameter<IReplacer>("ImmigrationReplacer", "Selects the population from the unification of the original population and the immigrants."));
+
+      #endregion
+
+      #region GeneralParameter   
+
+      Parameters.Add(new ValueParameter<IntValue>("Seed", "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
+      Parameters.Add(new ValueParameter<BoolValue>("SetSeedRandomly", "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
+      Parameters.Add(new ValueParameter<IntValue>("PopulationSize", "The size of the population of solutions.", new IntValue(100)));
+      Parameters.Add(new ValueParameter<MultiAnalyzer>("Analyzer", "The operator used to analyze the islands.", new MultiAnalyzer()));
+      Parameters.Add(new ConstrainedValueParameter<ISelector>("Selector", "The operator used to select solutions for reproduction."));
+      Parameters.Add(new ConstrainedValueParameter<ICrossover>("Crossover", "The operator used to cross solutions."));
+      Parameters.Add(new ValueParameter<PercentValue>("MutationProbability", "The probability that the mutation operator is applied on a solution.", new PercentValue(0.05)));
+      Parameters.Add(new OptionalConstrainedValueParameter<IManipulator>("Mutator", "The operator used to mutate solutions."));
+      Parameters.Add(new ValueParameter<IntValue>("Elites", "The numer of elite solutions which are kept in each generation.", new IntValue(1)));
+      Parameters.Add(new FixedValueParameter<BoolValue>("ReevaluateElites", "Flag to determine if elite individuals should be reevaluated (i.e., if stochastic fitness functions are used.)", new BoolValue(false)) {Hidden = true});
+      Parameters.Add(new ValueParameter<MultiTerminator>("Terminator", "The termination criteria that defines if the algorithm should continue or stop.", new MultiTerminator()));
+
+      #endregion
     }
 
@@ -546,7 +523,7 @@
 
       //add analyzer
-      GroupAnalyzer.Operators.Add(groupQualityAnalyzer, groupQualityAnalyzer.EnabledByDefault);
-      LayerAnalyzer.Operators.Add(layerQualityAnalyzer, layerQualityAnalyzer.EnabledByDefault);
-      IslandAnalyzer.Operators.Add(islandQualityAnalyzer, islandQualityAnalyzer.EnabledByDefault);
+      GroupAnalyzer.Operators.Add(groupQualityAnalyzer, false);
+      LayerAnalyzer.Operators.Add(layerQualityAnalyzer, false);
+      IslandAnalyzer.Operators.Add(islandQualityAnalyzer, false);
       Analyzer.Operators.Add(qualityAnalyzer, qualityAnalyzer.EnabledByDefault);
       //depth for each analyzer gets set when added
@@ -554,7 +531,7 @@
         foreach (var analyzer in Problem.Operators.OfType<IAnalyzer>()) {
           Analyzer.Operators.Add(analyzer, analyzer.EnabledByDefault);
-          IslandAnalyzer.Operators.Add((IAnalyzer)analyzer.Clone(),false);
-          LayerAnalyzer.Operators.Add((IAnalyzer)analyzer.Clone(), false);
-          GroupAnalyzer.Operators.Add((IAnalyzer) analyzer.Clone(),false);
+          IslandAnalyzer.Operators.Add((IAnalyzer) analyzer.Clone(), false);
+          LayerAnalyzer.Operators.Add((IAnalyzer) analyzer.Clone(), false);
+          GroupAnalyzer.Operators.Add((IAnalyzer) analyzer.Clone(), false);
         }
       }
@@ -583,5 +560,5 @@
         foreach (var terminator in Problem.Operators.OfType<ITerminator>())
           newTerminators.Add(terminator,
-            !Terminators.Operators.Contains(terminator) || Terminators.Operators.ItemChecked(terminator));
+                             !Terminators.Operators.Contains(terminator) || Terminators.Operators.ItemChecked(terminator));
       }
 
@@ -600,5 +577,5 @@
       MigrationRateParameter.ValueChanged += MigrationRate_ValueChanged;
 
-      Analyzer.Operators.ItemsAdded += AnalyzerOperators_ItemsAdded; 
+      Analyzer.Operators.ItemsAdded += AnalyzerOperators_ItemsAdded;
       IslandAnalyzer.Operators.ItemsAdded += IslandAnalyzerOperators_ItemsAdded;
       LayerAnalyzer.Operators.ItemsAdded += LayerAnalyzerOperators_ItemsAdded;
@@ -616,9 +593,8 @@
       NumberOfLayersParameter.ValueChanged += NumberOfLayersParameter_ValueChanged;
       NumberOfLayers.ValueChanged += NumberOfLayers_ValueChanged;
-
     }
 
     private void MigrationRate_ValueChanged(object sender, EventArgs e) {
-      var migrationSize = (int)Math.Ceiling(MigrationRateParameter.Value.Value * PopulationSize.Value);
+      var migrationSize = (int) Math.Ceiling(MigrationRateParameter.Value.Value*PopulationSize.Value);
       foreach (var selector in EmigrantsSelectorParameter.ValidValues) {
         selector.NumberOfSelectedSubScopesParameter.Value = new IntValue(migrationSize);
@@ -653,4 +629,5 @@
       }
     }
+
     private void LayerAnalyzerOperators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IAnalyzer>> e) {
       foreach (var analyzer in e.Items) {
@@ -684,31 +661,40 @@
       ParameterizeSelectors();
     }
+
     private void Elites_ValueChanged(object sender, EventArgs e) {
       ParameterizeSelectors();
     }
+
     private void PopulationSizeParameter_ValueChanged(object sender, EventArgs e) {
       ParameterizeSelectors();
     }
+
     private void PopulationSize_ValueChanged(object sender, EventArgs e) {
       ParameterizeSelectors();
     }
+
     private void NumberOfLayersParameter_ValueChanged(object sender, EventArgs e) {
       NumberOfLayers.ValueChanged += NumberOfLayers_ValueChanged;
       ParameterizeAgeLimits();
     }
+
     private void NumberOfLayers_ValueChanged(object sender, EventArgs e) {
       ParameterizeAgeLimits();
     }
+
     private void AgeGapParameter_ValueChanged(object sender, EventArgs e) {
       AgeGap.ValueChanged += AgeGap_ValueChanged;
       ParameterizeAgeLimits();
     }
+
     private void AgeGap_ValueChanged(object sender, EventArgs e) {
       ParameterizeAgeLimits();
     }
+
     private void AgingSchemeParameter_ValueChanged(object sender, EventArgs e) {
       AgingScheme.ValueChanged += AgingScheme_ValueChanged;
       ParameterizeAgeLimits();
     }
+
     private void AgingScheme_ValueChanged(object sender, EventArgs e) {
       ParameterizeAgeLimits();
@@ -717,11 +703,10 @@
     private void ParameterizeAgeLimits() {
       var scheme = AgingScheme.Value;
-      int ageGap = AgeGap.Value;
-      int numberOfLayers = NumberOfLayers.Value;
+      var ageGap = AgeGap.Value;
+      var numberOfLayers = NumberOfLayers.Value;
       AgeLimits = scheme.CalculateAgeLimits(ageGap, numberOfLayers);
     }
 
     private void ParameterizeMainLoop() {
-      //TODO
       MainLoop.AgeGapParameter.ActualName = AgeGapParameter.Name;
       MainLoop.AgeInheritanceParameter.ActualName = AgeInheritanceParameter.Name;
@@ -744,6 +729,4 @@
       MainLoop.ImmigrationReplacerParameter.ActualName = ImmigrationReplacerParameter.Name;
 
-
-
       MainLoop.PopulationSizeParameter.ActualName = PopulationSizeParameter.Name;
       MainLoop.CurrentPopulationSizeParameter.ActualName = "CurrentPopulationSize";
@@ -766,6 +749,6 @@
 
     private void ParametrizeMigration() {
-      var migrationSize = (int) Math.Ceiling(MigrationRateParameter.Value.Value *PopulationSize.Value);
-      foreach (ISelector selector in ApplicationManager.Manager.GetInstances<ISelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name)) {
+      var migrationSize = (int) Math.Ceiling(MigrationRateParameter.Value.Value*PopulationSize.Value);
+      foreach (var selector in ApplicationManager.Manager.GetInstances<ISelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name)) {
         selector.NumberOfSelectedSubScopesParameter.Value = new IntValue(migrationSize);
         selector.NumberOfSelectedSubScopesParameter.Hidden = true;
@@ -776,5 +759,5 @@
       }
 
-      foreach (IReplacer replacer in ApplicationManager.Manager.GetInstances<IReplacer>().OrderBy(x => x.Name)) {
+      foreach (var replacer in ApplicationManager.Manager.GetInstances<IReplacer>().OrderBy(x => x.Name)) {
         ParameterizeStochasticOperatorForLayer(replacer);
         ImmigrationReplacerParameter.ValidValues.Add(replacer);
@@ -807,5 +790,4 @@
           ParametrizeSingleObjectiveSelector(selector);
         }
-
       }
     }
